﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SilverMC
{
    public class Library
    {
        public string Url { get; set; }
        
        public string Name { get; set; }
        public bool ServerRequest { get; set; }
        public bool ClientRequest { get; set; }
        public string Comment { get; set; }
        public Native Natives { get; set; }
        public List<Rule> Rules { get; set; }
        public List<string> CheckSum { get; set; }
        public Extract Extract { get; set; }
    }

    public class GameData
    {
        public List<Library> Libraries { get; set; }
        public string MainClass { get; set; }
        public string Arguments { get; set; }
        public string Assets { get; set; }
    }

    public class Rule
    {
        public string Action { get; set; }
        public OS Os { get; set; }
    }

    public class OS
    {
        public string Name { get; set; }
        public string Version { get; set; }
    }

    public class Extract
    {
        public List<string> Exclude { get; set; }
    }

    public class Native
    {
        public string Windows { get; set; }
        public string OSX { get; set; }
        public string Linux { get; set; }
    }
}
