﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace SilverMC
{
    public partial class NewGameWindow : Form
    {
        public NewGameWindow(Versions vers, bool quickMode = false)
        {
            InitializeComponent();
            comboVersion.Items.Clear();
            for (int i = 0; i < vers.Games.Count; i++)
            {
                comboVersion.Items.Add(vers.Games[i].Id);
            }
            if (quickMode)
            {
                panel1.Visible = false;
            }
        }

        private void btnFinish_Click(object sender, EventArgs e)
        {
            if (textName.Text != null && textName.Text.Length > 0)
            {
                if (!Directory.Exists(Constants.BASE_PATH + "Games/" + textName.Text))
                {
                    if (radioHand.Checked && comboVersion.SelectedIndex != -1 && !textName.Text.Contains("\\") && !textName.Text.Contains("/"))
                    {
                        this.DialogResult = System.Windows.Forms.DialogResult.OK;
                        this.Hide();
                    }
                    else if (radioAuto.Checked && textFile.Text != null && textFile.Text.Length > 0 && File.Exists(textFile.Text))
                    {
                        this.DialogResult = System.Windows.Forms.DialogResult.OK;
                        this.Hide();
                    }
                }
                else
                {
                    MessageBox.Show("既に存在する名前です\r\n名前を違うものに変更してください", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void NewGameWindow_Load(object sender, EventArgs e)
        {

        }

        public string GetFileName()
        {
            return textFile.Text;
        }

        public bool IsHandMode()
        {
            return radioHand.Checked;
        }

        public int GetGameVersionIndex()
        {
            return comboVersion.SelectedIndex;
        }

        public string GetGameName()
        {
            return textName.Text;
        }

        private void btnRef_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                textFile.Text = openFileDialog1.FileName;
                openFileDialog1.FileName = "";
            }
        }

        private void radioHand_CheckedChanged(object sender, EventArgs e)
        {
            groupBox1.Enabled = radioHand.Checked;
            groupBox2.Enabled = radioAuto.Checked;
        }
    }

}
