﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Newtonsoft.Json.Converters;
using Ionic.Zip;

namespace SilverMC
{
    public partial class QuickRunWindow : Form
    {
        delegate void WindowClose();
        delegate void Dialog(string message);

        private string dirPath;
        private GameProfile profile;
        private Acount acount;
        private SilverMCData configData;
        private Bitmap backGroundImg;

        public QuickRunWindow(string directory, GameProfile version, Acount loginAcount, SilverMCData config, QuickPlayData qpd)
        {
            InitializeComponent();
            dirPath = directory;
            profile = version;
            acount = loginAcount;
            configData = config;
            if (qpd.LoadImage != null)
            {
                WebClient cl = new WebClient();
                byte[] pic = cl.DownloadData(qpd.LoadImage);
                MemoryStream st = new MemoryStream(pic);
                backGroundImg = new Bitmap(st);
                st.Close();
                this.Width = backGroundImg.Width;
                this.Height = backGroundImg.Height;
                pictureBox1.Width = this.Width;
                pictureBox1.Height = this.Height;
                pictureBox1.Image = backGroundImg;
                label.Location = new Point(8, this.Height - 24);
                progressBar.Location = new Point(55, this.Height - 24);
                progressBar.Size = new Size(this.Width - 67, 12);
                cl.Dispose();
            }
            
            
        }

        private void background_DoWork(object sender, DoWorkEventArgs e)
        {
            GameRunning gr = new GameRunning(dirPath, profile, acount, configData);
            gr.SetControl(this, label, progressBar);
            if (gr.Run())
            {
                WindowHide();
            }
            else
            {
                WindowHide();
            }
            return;
        }

        private void RunWindow_Load(object sender, EventArgs e)
        {
            background.RunWorkerAsync();
        }

        private void RunWindow_FormClosing(object sender, FormClosingEventArgs e)
        {

        }

        public void GameRun()
        {
            background.RunWorkerAsync();
        }

        private void WindowHide()
        {
            this.Invoke(new WindowClose(ThisClose));
        }

        private void ThisClose()
        {
            this.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.Hide();
            Utils.ForceGarbageCollection();
        }
    }
}
