﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Newtonsoft.Json.Converters;
using Ionic.Zip;

namespace SilverMC
{
    public partial class RunWindow : Form
    {
        delegate void WindowClose();

        private string dirPath;
        private GameProfile profile;
        private Acount acount;
        private SilverMCData configData;

        public RunWindow(string directory, GameProfile version, Acount loginAcount, SilverMCData config)
        {
            InitializeComponent();
            dirPath = directory;
            profile = version;
            acount = loginAcount;
            configData = config;
        }

        private void background_DoWork(object sender, DoWorkEventArgs e)
        {
            GameRunning gr = new GameRunning(dirPath, profile, acount, configData);
            gr.SetControl(this, label, progressBar);
            if (gr.Run())
            {
                WindowHide();
            }
            else
            {
                WindowHide();
            }
            return;
        }

        private void RunWindow_Load(object sender, EventArgs e)
        {
            background.RunWorkerAsync();
        }

        private void RunWindow_FormClosing(object sender, FormClosingEventArgs e)
        {

        }

        public void GameRun()
        {
            background.RunWorkerAsync();
        }

        private void WindowHide()
        {
            this.Invoke(new WindowClose(ThisClose));
        }

        private void ThisClose()
        {
            this.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.Hide();
            Utils.ForceGarbageCollection();
        }
    }
}
