﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.Net;
using System.IO;
using SilverNBTLibrary;
namespace SilverMC
{
    public class ServerJoin
    {
        private string ipAddress;
        private int port;

        public ServerJoin(string ip)
        {
            if (ip.Contains(":"))
            {
                string[] array = ipAddress.Split(':');
                ipAddress = array[0];
                port = Int32.Parse(array[1]);
            }
            else
            {
                ipAddress = ip;
                port = 25565;
            }
        }

        public void Start()
        {
            try
            {
                Console.WriteLine("Join {0}:{1}", ipAddress, port);
                TcpClient tcp = new TcpClient(ipAddress, port);
                tcp.SendTimeout = 3000;
                NetworkStream ns = tcp.GetStream();
                ns.WriteByte(0xFE);

                MemoryStream ms = new MemoryStream();
                byte[] resBytes = new byte[256];
                do
                {
                    int resSize = ns.Read(resBytes, 0, resBytes.Length);
                    if (resSize == 0)
                    {
                        Console.WriteLine("サーバーが切断しました。");
                        break;
                    }
                    ms.Write(resBytes, 0, resSize);
                } while (ns.DataAvailable);
                byte[] mem = ms.ToArray();

                Console.WriteLine(Encoding.GetEncoding("utf-16be").GetString(mem, 3, mem.Length - 3));
                //string resMsg = Encoding.UTF8.GetString(ms.ToArray());
                ms.Close();
                //Console.WriteLine(resMsg);

                ns.Close();
                tcp.Close();
            }
            catch (Exception)
            {

            }
        }
    }
}
