﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SilverMC
{
    public class SilverMCData
    {
        public Guid ClientId { get; set; }
        public string[] Buttons { get; set; }
        public List<Acount> Acounts { get; set; }
        public List<QuickPlayData> QuickPlays { get; set; }
        public int DefaultAcount { get; set; }
        public string JavaPath { get; set; }
        public string DrawString { get; set; }
        public int ListDrawMode { get; set; }
        public bool NormalMode { get; set; }
        public bool OfflinePlay { get; set; }
        public bool StartWait { get; set; }
    }

    public class QuickPlayData
    {
        public QuickPlayData() { }

        public QuickPlayData(string[] array)
        {
            if (array[2].Contains(":"))
            {
                string[] addresses = array[2].Split(':');
                if (addresses.Length == 2)
                {
                    ServerAddress = addresses[0];
                    int port;
                    if (Int32.TryParse(addresses[1], out port))
                    {
                        ServerPort = port;
                    }
                }
            }
            if (array.Length > 2)
            {
                string baseText = array[3];
                if (baseText != null && baseText != "" && baseText.Length > 0)
                {
                    ServerName = System.Text.Encoding.UTF8.GetString(System.Convert.FromBase64String(baseText));
                }
                else
                {
                    ServerName = "";
                }
            }
            if (array.Length > 3)
            {
                string baseText = array[4];
                if (baseText != null && baseText != "" && baseText.Length > 0)
                {
                    LoadImage = System.Text.Encoding.UTF8.GetString(System.Convert.FromBase64String(baseText));
                    if (LoadImage.StartsWith("0"))
                    {
                        LoadImage = LoadImage.Substring(1);
                    }
                }
            }
        }

        public string ServerName { get; set; }
        public string ServerAddress { get; set; }
        public int ServerPort { get; set; }
        public string LoadImage { get; set; }

        public string GameDirectory { get; set; }

        public override string ToString()
        {
            return "QuickPlayData{" + ServerName + " " + ServerAddress + ":" + ServerPort + " " + LoadImage + "}";
        }

        public string GetServerString()
        {
            return ServerAddress + ":" + ServerPort;
        }
    }
}
