﻿using System.IO;

namespace SilverNBTLibrary
{
    public class NBTTagByte : NBTBase
    {
        private byte data;

        public NBTTagByte(string name) : base(name) { }

        public NBTTagByte(string name, byte value)
            : base(name)
        {
            data = value;
        }

        public override byte GetId()
        {
            return (byte)1;
        }

        public override object GetResult()
        {
            return data;
        }

        public override void WriteData(BinaryWriter bw)
        {
            bw.WriteHelper(data);
        }

        public override void LoadData(BinaryReader br)
        {
            data = br.ReadByteHelper();
        }

        public override bool SetValue(object obj)
        {
            byte o;
            bool n = byte.TryParse(obj.ToString(), out o);
            if (n) data = (byte)o;
            return n;
        }

        public override NBTBase Clone()
        {
            NBTTagByte clone = new NBTTagByte(Name);
            clone.Expand = this.Expand;
            clone.SetValue(data);
            return clone;
        }
    }
}
