﻿using System.IO;

namespace SilverNBTLibrary
{
    public class NBTTagDouble : NBTBase
    {
        private double data;

        public NBTTagDouble(string name) : base(name) { }

        public NBTTagDouble(string name, double value)
            : base(name)
        {
            data = value;
        }

        public override byte GetId()
        {
            return (byte)6;
        }

        public override object GetResult()
        {
            return data;
        }

        public override void WriteData(BinaryWriter bw)
        {
            bw.WriteHelper(data);
        }

        public override void LoadData(BinaryReader br)
        {
            data = br.ReadDoubleHelper();
        }

        public override bool SetValue(object obj)
        {
            double o;
            bool n = double.TryParse(obj.ToString(), out o);
            if (n) data = (double)o;
            return n;
        }

        public override NBTBase Clone()
        {
            NBTTagDouble clone = new NBTTagDouble(Name);
            clone.Expand = this.Expand;
            clone.SetValue(data);
            return clone;
        }
    }
}
