﻿using System.IO;

namespace SilverNBTLibrary
{
    public class NBTTagFloat : NBTBase
    {
        private float data;

        public NBTTagFloat(string name) : base(name) { }

        public NBTTagFloat(string name, float value)
            : base(name)
        {
            data = value;
        }

        public override byte GetId()
        {
            return (byte)5;
        }

        public override object GetResult()
        {
            return data;
        }

        public override void WriteData(BinaryWriter bw)
        {
            bw.WriteHelper(data);
        }

        public override void LoadData(BinaryReader br)
        {
            data = br.ReadSingleHelper();
        }

        public override bool SetValue(object obj)
        {
            float o;
            bool n = float.TryParse(obj.ToString(), out o);
            if (n) data = (float)o;
            return n;
        }

        public override NBTBase Clone()
        {
            NBTTagFloat clone = new NBTTagFloat(Name);
            clone.Expand = this.Expand;
            clone.SetValue(data);
            return clone;
        }
    }
}
