﻿using System.IO;

namespace SilverNBTLibrary
{
    public class NBTTagInt : NBTBase
    {
        private int data;

        public NBTTagInt(string name) : base(name) { }

        public NBTTagInt(string name, int value)
            : base(name)
        {
            data = value;
        }

        public override byte GetId()
        {
            return (byte)3;
        }

        public override object GetResult()
        {
            return data;
        }

        public override void WriteData(BinaryWriter bw)
        {
            bw.WriteHelper(data);
        }

        public override void LoadData(BinaryReader br)
        {
            data = br.ReadInt32Helper();
        }

        public override bool SetValue(object obj)
        {
            int o;
            bool n = int.TryParse(obj.ToString(), out o);
            if (n) data = (int)o;
            return n;
        }

        public override NBTBase Clone()
        {
            NBTTagInt clone = new NBTTagInt(Name);
            clone.Expand = this.Expand;
            clone.SetValue(data);
            return clone;
        }

    }
}
