﻿using System.IO;

namespace SilverNBTLibrary
{
    public class NBTTagLong : NBTBase
    {
        private long data;

        public NBTTagLong(string name) : base(name) { }

        public NBTTagLong(string name, long value)
            : base(name)
        {
            data = value;
        }

        public override byte GetId()
        {
            return (byte)4;
        }

        public override object GetResult()
        {
            return data;
        }

        public override void WriteData(BinaryWriter bw)
        {
            bw.WriteHelper(data);
        }

        public override void LoadData(BinaryReader br)
        {
            data = br.ReadInt64Helper();
        }

        public override bool SetValue(object obj)
        {
            long o;
            bool n = long.TryParse(obj.ToString(), out o);
            if (n) data = (long)o;
            return n;
        }

        public override NBTBase Clone()
        {
            NBTTagLong clone = new NBTTagLong(Name);
            clone.Expand = this.Expand;
            clone.SetValue(data);
            return clone;
        }
    }
}
