﻿using System.IO;

namespace SilverNBTLibrary
{
    public class NBTTagShort : NBTBase
    {
        private short data;

        public NBTTagShort(string name) : base(name) { }

        public NBTTagShort(string name, short value)
            : base(name)
        {
            data = value;
        }

        public override byte GetId()
        {
            return (byte)2;
        }

        public override object GetResult()
        {
            return data;
        }

        public override void WriteData(BinaryWriter bw)
        {
            bw.WriteHelper(data);
        }

        public override void LoadData(BinaryReader br)
        {
            data = br.ReadInt16Helper();
        }

        public override bool SetValue(object obj)
        {
            short o;
            bool n = short.TryParse(obj.ToString(), out o);
            if (n) data = (short)o;
            return n;
        }

        public override NBTBase Clone()
        {
            NBTTagShort clone = new NBTTagShort(Name);
            clone.Expand = this.Expand;
            clone.SetValue(data);
            return clone;
        }
    }
}
