﻿using System.IO;

namespace SilverNBTLibrary
{
    public class NBTTagString : NBTBase
    {
        private string data;

        public NBTTagString(string name) : base(name) { }

        public NBTTagString(string name, string value)
            : base(name)
        {
            data = value;
        }

        public override byte GetId()
        {
            return (byte)8;
        }

        public override object GetResult()
        {
            return data;
        }

        public override void WriteData(BinaryWriter bw)
        {
            bw.WriteHelper(data);
        }

        public override void LoadData(BinaryReader br)
        {
            data = br.ReadStringHelper();
        }

        public override bool SetValue(object obj)
        {
            data = (string)obj;
            return true;
        }

        public override NBTBase Clone()
        {
            NBTTagString clone = new NBTTagString(Name);
            clone.Expand = this.Expand;
            clone.SetValue(data);
            return clone;
        }
    }
}
