﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SilverMC
{
    public class UserProfile
    {
        public string Id { get; set; }
        public string Name { get; set; }
        public bool Legacy { get; set; }

        public override string ToString()
        {
            return Id + " " + Name + " " + Legacy;
        }
    }

    public class User
    {
        public string Id { get; set; }
        public List<Property> Properties;

        public class Property
        {
            public string Name { get; set; }
            public string Value { get; set; }
        }
    }

    public class RefrashRequest
    {
        public string AccessToken { get; set; }
        public string ClinetToken { get; set; }
        
        public UserProfile SelectedProfile { get; set; }
        public bool RequestUser { get; set; }

        public RefrashRequest(UserProfile profile)
        {
            SelectedProfile = profile;
            RequestUser = true;
        }
    }

    public class AuthResponce
    {
        public string AccessToken { get; set; }
        public string ClinetToken { get; set; }

        public UserProfile SelectedProfile { get; set; }
        public UserProfile[] AvailableProfiles { get; set; }

        public User User;

        public override string ToString()
        {
            return "AccessToken:" + AccessToken + " ClinetToken" + ClinetToken + " User" + User + " SelectedProfile" + SelectedProfile.ToString();
        }

        public string GetAcountType()
        {
            if (SelectedProfile != null)
            {
                return SelectedProfile.Legacy ? "legacy" : "mojang";
            }
            else if(AvailableProfiles != null && AvailableProfiles.Length > 0)
            {
                return AvailableProfiles[0].Legacy ? "legacy" : "mojang";
            }
            return "legacy";
        }
    }
}
